#include "fileio.ch"
#include "directry.ch"
#include "dbstruct.ch"
#define cNormal "W+/B,B/W"
#define cEndfield CHR(222)+CHR(49)+CHR(04)+CHR(00)+CHR(04)+CHR(00)+CHR(49);
    +CHR(222)+CHR(10)
#define cEndrecord CHR(222)+CHR(52)+CHR(06)+CHR(00)+CHR(00)+CHR(00)+CHR(06)+CHR(00);
   +CHR(52)+CHR(222)+CHR(10)
#define cHeader CHR(255)+CHR(87)+CHR(80)+CHR(67)+CHR(94)+CHR(00)+CHR(00)+CHR(00);
   +CHR(01)+CHR(10)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00);
   +CHR(251)+CHR(255)+CHR(05)+CHR(00)+CHR(50)+CHR(00)+CHR(00)+CHR(00);
   +CHR(00)+CHR(00)+CHR(06)+CHR(00)+CHR(08)+CHR(00)+CHR(00)+CHR(00);
   +CHR(66)+CHR(00)+CHR(00)+CHR(00)+CHR(08)+CHR(00)+CHR(02)+CHR(00);
   +CHR(00)+CHR(00)+CHR(74)+CHR(00)+CHR(00)+CHR(00)+CHR(01)+CHR(00);
   +CHR(12)+CHR(00)+CHR(00)+CHR(00)+CHR(79)+CHR(00)+CHR(00)+CHR(00);
   +CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00);
   +CHR(00)+CHR(00)+CHR(08)+CHR(00)+CHR(124)+CHR(00)+CHR(120)+CHR(00);
   +CHR(00)+CHR(00)+CHR(00)+CHR(00)
#define cPad CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00);
   +CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00)+CHR(00);
   +CHR(00)+CHR(00)
#define cDate LEFT(CMONTH(DATE())+' '+LTRIM(STR(DAY(DATE())))+',';
   +LTRIM(STR(YEAR(DATE())))+cPad,18)

SETCOLOR(cNormal)
CLEAR SCREEN
SET CONSOLE OFF

IF (nHandle:=FCREATE("MERGE.SF", FC_NORMAL))=-1
    ?"File cannot be created"+ FERROR()
    QUIT
ENDIF

FWRITE(nHandle,cHeader+cDate)
SET CONSOLE ON
PRIVATE aDirectory:=DIRECTORY("*.dbf"),aDbf_files:={},aNtx_files:={}
PRIVATE nSelection:=0, nLeft:=0, nRight:=39, nNumfields:=0
PRIVATE cString:="Choose a database"
AEVAL(aDirectory, {|afile| AADD(aDbf_files,afile[F_NAME])} )
ASORT(aDbf_files)
aDirectory:=DIRECTORY("*.ntx")
AEVAL(aDirectory, {|afile| AADD(aNtx_files,afile[F_NAME])} )
ASORT(aNtx_files)
CLEAR SCREEN
@ 1,1 TO 23,39 DOUBLE
@ 24,center(cString,nLeft,nRight) SAY cString
nSelection=ACHOICE(2,2,22,38,aDbf_files)
IF nSelection=0
   QUIT
ENDIF
xaDatabase=left(aDbf_files[nSelection],len(aDbf_files[nSelection])-4)
@ 1,40 TO 23,79 DOUBLE
cString:="Choose an index"
nLeft:=40
nRight:=80
@ 24,center(cString,nLeft,nRight) SAY cString
nSelection=ACHOICE(2,41,22,78,aNtx_files)
IF nSelection # 0
    xaIndex=aNtx_files[nSelection]
    USE (xaDatabase) INDEX (xaIndex) NEW
ELSE
    USE (xaDatabase) NEW
ENDIF
PRIVATE aStruct:= &xaDatabase->(DBSTRUCT()),aNames:={}
AEVAL(aStruct, {|aField|   AADD(aNames,;
                                space(1);
                                +PADR(aField[DBS_NAME],15);
                                +aField[DBS_TYPE]+space(2);
                                +PADL(ALLTRIM(STR(aField[DBS_LEN])),5);
                                +PADL(ALLTRIM(STR(aField[DBS_DEC])),5);
                                 );
               };
     )
nLeft:=0
nRight:=80
nPos:=0
I:=1
CLEAR SCREEN
@ 1,1 TO 23,39 DOUBLE
@ 1,40 TO 23,79 DOUBLE
cString="Press Esc to Complete Selection"
@ 24,CENTER(cString,nLeft,nRight) SAY cString
nSelection:=1
PRIVATE aFnames[len(aNames)]
DO WHILE nSelection #0
    CLEAR TYPEAHEAD
    nSelection=ACHOICE(2,2,22,38,aNames)
    IF nSelection #0
        if left(aNames[nSelection],1)=CHR(251)
            aNames[nSelection]:=space(1)+right(aNames[nSelection],len(aNames[nSelection])-1)
            nPos:=ASCAN(aFnames,trim(left(aNames[nSelection],10)))
            if nPos>0
                ADEL(aFnames,nPos)
                @ 2,41 clear to 22,78
                KEYBOARD CHR(13)
                ACHOICE(2,41,22,78,aFnames)
                I--
            endif
        else
            aFnames[i]=TRIM(LEFT(aNames[nSelection],10))
            aNames[nSelection]=CHR(251)+LTRIM(aNames[nSelection])
            @ 2,41 clear to 22,78
            KEYBOARD CHR(13)
            ACHOICE(2,41,22,78,aFnames)
            I++
        endif
    ENDIF
ENDDO
nNumfields:=I-1
CLEAR SCREEN
@ 10,20 SAY "Writing to file..."
SET CONSOLE OFF
DO WHILE .NOT. EOF()
   FOR J=1 TO nNumfields
      mfname=aFnames[j]
      mmname=&mfname
      checktype(mfname,@mmname)
      FWRITE(nHandle,TRIM(mmname)+cEndfield)
   NEXT
   FWRITE(nHandle,cEndrecord)
   SKIP
ENDDO
FCLOSE(nHandle)
SET CONSOLE ON
CLEAR SCREEN
CLOSE DATABASES

FUNCTION checktype
PARAMETER name, value
DO CASE
CASE TYPE(name)='C'
CASE TYPE(name)='N'
   value=ALLTRIM(STR(value))
CASE TYPE(name)='D'
   value= DTOC(value)
CASE TYPE(name)='L'
CASE TYPE(name)='M'
   KEYBOARD CHR(23)
   value= MEMOEDIT(value,1,1,23,79)
ENDCASE
RETURN 0


FUNCTION CENTER
PARAMETERS cString,nLeft,nRight
bBlock:={|string,left,right| left+INT((right-left)-LEN(string))/2}
return (EVAL(bBlock,cString,nLeft,nRight))
